osg::LOD Class Reference

`#include <LOD>`

Inheritance diagram for osg::LOD:

## Public Types

enum | CenterMode { USE_BOUNDING_SPHERE_CENTER , USER_DEFINED_CENTER , UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED }
enum | RangeMode { DISTANCE_FROM_EYE_POINT , PIXEL_SIZE_ON_SCREEN }
typedef osg::BoundingSphere::vec_type | vec_type
typedef osg::BoundingSphere::value_type | value_type
typedef std::pair< float, float > | MinMaxPair
typedef std::vector< MinMaxPair > | RangeList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| LOD ()
| LOD (const LOD &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, LOD)
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
virtual bool | addChild (Node *child, float rmin, float rmax)
template<class T>
bool | addChild (const ref_ptr< T > &child, float rmin, float rmax)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove=1)
void | setCenterMode (CenterMode mode)
CenterMode | getCenterMode () const
void | setCenter (const vec_type &center)
const vec_type & | getCenter () const
void | setRadius (value_type radius)
value_type | getRadius () const
void | setRangeMode (RangeMode mode)
RangeMode | getRangeMode () const
void | setRange (unsigned int childNo, float min, float max)
float | getMinRange (unsigned int childNo) const
float | getMaxRange (unsigned int childNo) const
unsigned int | getNumRanges () const
void | setRangeList (const RangeList &rangeList)
const RangeList & | getRangeList () const
virtual BoundingSphere | computeBound () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~LOD ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

CenterMode | _centerMode
vec_type | _userDefinedCenter
value_type | _radius
RangeMode | _rangeMode
RangeList | _rangeList
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

LOD - Level Of Detail group node which allows switching between children depending on distance from eye point. Typical uses are for load balancing - objects further away from the eye point are rendered at a lower level of detail, and at times of high stress on the graphics pipeline lower levels of detail can also be chosen by adjusting the viewers's Camera/CullSettings LODScale value. Each child has a corresponding valid range consisting of a minimum and maximum distance. Given a distance to the viewer (d), LOD displays a child if min <= d < max. LOD may display multiple children simultaneously if their corresponding ranges overlap. Children can be in any order, and don't need to be sorted by range or amount of detail. If the number of ranges (m) is less than the number of children (n), then children m+1 through n are ignored.

## Member Typedef Documentation

## MinMaxPair

typedef std::pair<float,float> osg::LOD::MinMaxPair

## RangeList

typedef std::vector<MinMaxPair> osg::LOD::RangeList

## value_type

typedef osg::BoundingSphere::value_type osg::LOD::value_type

## vec_type

typedef osg::BoundingSphere::vec_type osg::LOD::vec_type

## Member Enumeration Documentation

## CenterMode

enum osg::LOD::CenterMode

Modes which control how the center of object should be determined when computing which child is active. Furthermore it determines how the bounding sphere is calculated.

Enumerator
USE_BOUNDING_SPHERE_CENTER | Uses the bounding sphere's center as the center of object and the geometrical bounding sphere of the node's children.
USER_DEFINED_CENTER | Uses the user defined center as the center of object; the bounding sphere is determined by the user defined center and user defined radius.
UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED | Uses the user defined center as the center of object; the bounding sphere is the user defined bounding sphere expanded by the geometrical bounding sphere of the node's children.

## RangeMode

enum osg::LOD::RangeMode

Modes that control how the range values should be interpreted when computing which child is active.

Enumerator
DISTANCE_FROM_EYE_POINT |
PIXEL_SIZE_ON_SCREEN |

## Constructor & Destructor Documentation

## LOD() [1/2]

osg::LOD::LOD | ( |  | ) |

Default constructor The default constructor sets

- the center mode to USE_BOUNDING_SPHERE,
- the radius to a value smaller than zero and
- the range mode to DISTANCE_FROM_EYE_POINT.

Referenced by osgSim::Impostor::Impostor(), LOD(), and META_Node().

## LOD() [2/2]

osg::LOD::LOD | ( | const LOD & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References LOD(), and osg::CopyOp::SHALLOW_COPY.

## ~LOD()

virtual osg::LOD::~LOD | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addChild() [1/4]

template<class T>

bool osg::Group::addChild | ( | const ref_ptr< T > & | child | ) |

inline

## addChild() [2/4]

template<class T>

bool osg::LOD::addChild | ( | const ref_ptr< T > & | child,
|  | float | rmin,
|  | float | rmax )

inline

References addChild(), and osg::ref_ptr< T >::get().

Referenced by addChild().

## addChild() [3/4]

virtual bool osg::LOD::addChild | ( | Node * | child | ) |

virtual

Add Node to Group. If node is not NULL then increment its reference count, add it to the child list and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. Otherwise return false. Scene nodes can't be added as child nodes.

Reimplemented from osg::Group.

Reimplemented in osg::PagedLOD.

## addChild() [4/4]

virtual bool osg::LOD::addChild | ( | Node * | child,
|  | float | rmin,
|  | float | rmax )

virtual

Reimplemented in osg::PagedLOD.

## computeBound()

virtual BoundingSphere osg::LOD::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

Reimplemented in osgSim::Impostor.

## getCenter()

const vec_type & osg::LOD::getCenter | ( |  | ) | const

inline

return the LOD center point.

References _centerMode, _userDefinedCenter, osg::Node::getBound(), UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED, and USER_DEFINED_CENTER.

## getCenterMode()

CenterMode osg::LOD::getCenterMode | ( |  | ) | const

inline

Get how the center of object should be determined when computing which child is active.

References _centerMode.

## getMaxRange()

float osg::LOD::getMaxRange | ( | unsigned int | childNo | ) | const

inline

returns the max visible range for specified child.

References _rangeList.

## getMinRange()

float osg::LOD::getMinRange | ( | unsigned int | childNo | ) | const

inline

returns the min visible range for specified child.

References _rangeList.

## getNumRanges()

unsigned int osg::LOD::getNumRanges | ( |  | ) | const

inline

returns the number of ranges currently set. An LOD which has been fully set up will have getNumChildren()==getNumRanges().

References _rangeList.

## getRadius()

value_type osg::LOD::getRadius | ( |  | ) | const

inline

Get the object-space radius of the volume enclosed by the LOD.

References _radius.

## getRangeList()

const RangeList & osg::LOD::getRangeList | ( |  | ) | const

inline

return the list of MinMax ranges for each child.

References _rangeList.

## getRangeMode()

RangeMode osg::LOD::getRangeMode | ( |  | ) | const

inline

Get how the range values should be interpreted when computing which child is active.

References _rangeMode.

## META_Node()

osg::LOD::META_Node | ( | osg | ,
|  | LOD | )

References LOD().

## removeChildren()

virtual bool osg::LOD::removeChildren | ( | unsigned int | pos,
|  | unsigned int | numChildrenToRemove = 1 )

virtual

Remove children from Group. Note, must be override by subclasses of Group which add per child attributes.

Reimplemented from osg::Group.

Reimplemented in osg::PagedLOD.

## setCenter()

void osg::LOD::setCenter | ( | const vec_type & | center | ) |

inline

Sets the object-space point which defines the center of the osg::LOD. center is affected by any transforms in the hierarchy above the osg::LOD.

Note
  This method also changes the center mode to USER_DEFINED_CENTER if the current center mode does not use a user defined center!

See also
  setRadius

References _centerMode, _userDefinedCenter, UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED, and USER_DEFINED_CENTER.

## setCenterMode()

void osg::LOD::setCenterMode | ( | CenterMode | mode | ) |

inline

Set how the center of object should be determined when computing which child is active.

References _centerMode.

## setRadius()

void osg::LOD::setRadius | ( | value_type | radius | ) |

inline

Set the object-space reference radius of the volume enclosed by the LOD.

Parameters

  radius | Radius must be larger or equal to zero. If the radius is smaller than zero the geometrical bounding sphere of the node's children is used as the LOD's bounding sphere regardless of the center mode setting.

Remarks
  The radius is only used to calculate the bounding sphere.

See also
  setCenter

References _radius.

## setRange()

void osg::LOD::setRange | ( | unsigned int | childNo,
|  | float | min,
|  | float | max )

Sets the min and max visible ranges of range of specific child. Values are floating point distance specified in local objects coordinates.

## setRangeList()

void osg::LOD::setRangeList | ( | const RangeList & | rangeList | ) |

inline

set the list of MinMax ranges for each child.

References _rangeList.

## setRangeMode()

void osg::LOD::setRangeMode | ( | RangeMode | mode | ) |

inline

Set how the range values should be interpreted when computing which child is active.

References _rangeMode.

## traverse()

virtual void osg::LOD::traverse | ( | NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

Reimplemented in osg::PagedLOD, and osgSim::Impostor.

References osg::Group::addChild().

## Member Data Documentation

## _centerMode

CenterMode osg::LOD::_centerMode

protected

Referenced by getCenter(), getCenterMode(), setCenter(), and setCenterMode().

## _radius

value_type osg::LOD::_radius

protected

Referenced by getRadius(), and setRadius().

## _rangeList

RangeList osg::LOD::_rangeList

protected

Referenced by getMaxRange(), getMinRange(), getNumRanges(), getRangeList(), and setRangeList().

## _rangeMode

RangeMode osg::LOD::_rangeMode

protected

Referenced by getRangeMode(), and setRangeMode().

## _userDefinedCenter

vec_type osg::LOD::_userDefinedCenter

protected

Referenced by getCenter(), and setCenter().

The documentation for this class was generated from the following file:

- LOD